/*********************************************************
* Conversion d'image RGB­> HSV > RGB
* Date: 24-Mai-2021
* Auteur: Yann Roberge
*********************************************************/

#include "main.h"
#include "rgb2hsv.h"

#include <stdio.h>
#include <stdint.h>
#include <string.h>

// Load raw image to memory. Images should be in
int loadFrameFromDisk(const PixelRGB8* imageRGB, int index) {
    char filepath[100];
    sprintf(filepath, "%s%s%d", FRAME_IN_DIRECTORY, FRAME_IN_FILENAME, index);
    FILE* fd = fopen(filepath, "r");

    int i, status;
    for (i=0; i< IMG_AREA; i++) {
        status = fread((void*) &imageRGB[i], BYTES_PER_PIXEL, 1, fd);
        if (status < 0) {
            fprintf(stderr, "Error while reading %s\n", filepath);
            fclose(fd);
            return status;
        }
    }
    fclose(fd);
    return 0;
}

int writeFrameToDisk(const PixelRGB8* imageRGB, int index) {
    char filepath[100];
    sprintf(filepath, "%s%s%d", FRAME_OUT_DIRECTORY, FRAME_OUT_FILENAME, index);
    FILE* fd = fopen(filepath, "w");

    int i, status;
    for (i=0; i< IMG_AREA; i++) {
        status = fwrite((void*) &imageRGB[i], BYTES_PER_PIXEL, 1, fd);
        if (status < 0) {
            fprintf(stderr, "Error while reading %s\n", filepath);
            fclose(fd);
            return status;
        }
    }
    fclose(fd);
    return 0;
}

int correctPixelColor(const PixelRGB8* pixel, int deltaHue, int deltaSaturation, int deltaValue) {
    // TODO: Implémenter
    printf("Pixel: %d %d %d\n", pixel->red, pixel->green, pixel->blue);

    // Convert to HSV

    // Add corrections

    // Convert back to RGB

    return 0;
}

// Pass hue, saturation and value (lightness / 2) corrections to args
int main(int argc, char* argv) {
    // Start timing
    // TODO: Mesurer le nombre d'image par secondes traitées. Objectif 30fps
    const PixelRGB8 imageRGB[IMG_AREA];

    int i, j;
    for (i=0; i<N_IMAGES; i++) {
        loadFrameFromDisk(imageRGB, i);

        // Apply correction to each pixel
        for (j=0; j<IMG_AREA; j++) {
            correctPixelColor(&imageRGB[j], DELTA_HUE,
                                    DELTA_SATURATION, DELTA_VALUE);
        }

        writeFrameToDisk(imageRGB, i);
    }

    // Stop timing
    printf("Done.\n");
    return 0;
}

