/*********************************************************
* Conversion d'image RGB­> HSV > RGB
* Date: 25-Mai-2021
* Auteur: Yann Roberge
*********************************************************/

#include <stdint.h>

// Image definition
#define N_IMAGES        100
#define IMG_WIDTH       640
#define IMG_HEIGHT      360
#define IMG_AREA        (IMG_WIDTH * IMG_HEIGHT)
#define IMG_DEPTH       8 // bits
#define IMG_N_CHANNELS  3 // RGB

#define BYTES_PER_PIXEL (IMG_N_CHANNELS * IMG_DEPTH / 8)
#define FRAME_BUF_SIZE  (IMG_AREA * BYTES_PER_PIXEL)

// Files and directories
#define FRAME_IN_DIRECTORY "/run/user/1000/gvfs/sftp:host=odroid,user=nas/media/raid/frames/"
#define FRAME_OUT_DIRECTORY "/run/user/1000/gvfs/sftp:host=odroid,user=nas/media/raid/frames_out/"

#define FRAME_IN_FILENAME "frame"
#define FRAME_OUT_FILENAME "frameout"

// Corrections to apply
#define DELTA_HUE           50
#define DELTA_SATURATION    50
#define DELTA_VALUE         50

// Pixel struct unpacked for processing
typedef struct {
    uint8_t red;
    uint8_t green;
    uint8_t blue;
    uint8_t RESERVED;
} PixelRGB8;

// Functions
int loadFrameFromDisk(const PixelRGB8* imageRGB, int index);
int writeFrameToDisk(const PixelRGB8* imageRGB, int index);
int correctPixelColor(const PixelRGB8* pixel, int deltaHue, int deltaSaturation,
                                        int deltaValue);

